<?php

namespace Egoi\Marketing\Setup\Patch\Data;

use Magento\Framework\Setup\Patch\DataPatchInterface;
use Magento\Framework\App\Config\ConfigResource\ConfigInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;

class RegisterInstallDate implements DataPatchInterface
{

    private $configWriter;

    private $moduleDataSetup;

    public function __construct(
        ConfigInterface $configWriter,
        ModuleDataSetupInterface $moduleDataSetup
    ) {

        $this->configWriter = $configWriter;
        $this->moduleDataSetup = $moduleDataSetup;
    }

    public function apply()
    {

        $this->moduleDataSetup->getConnection()->startSetup();

        $this->configWriter->saveConfig(
            'egoi/install/date',
            (new \DateTime())->format('Y-m-d H:i:s'),
            'default',
            0
        );

        $this->moduleDataSetup->getConnection()->endSetup();
    }

    public static function getDependencies()
    {

        return [];
    }

    public function getAliases()
    {

        return [];
    }
}
